<template>
	<mind-layout>
		<template slot="toolbar-actions">
			<el-button type="primary" icon="el-icon-error" size="small" 
				@click="eventList = []" >Limpiar</el-button>
		</template>
		<!-- <div class="container"> -->
			<el-table
			height="100%"
      :data="eventList"
      style="width: 100%">
      <el-table-column
        prop="Event"
        label="Evento"
        width="150" sortable >
      </el-table-column>
      <el-table-column
				sortable
        prop="Timestamp"
        label="Timestamp"
        width="180">
      </el-table-column>
      <el-table-column  label="Detalle">
				<template slot-scope="{row}">
					<el-row>
						<el-col :xs="24" :lg="8" :xl="6" 
							v-for="(v, k) in row.Details" :key="k">
							<b>{{k}}</b>: <span>{{v}}</span>
						</el-col>
					</el-row>
					<!-- <div v-for="(v, k) in row.Details" :key="k">
						<b>{{k}}</b>: <span>{{v}}</span>
					</div> -->
				</template>
      </el-table-column>
    </el-table>
	<!-- </div> -->
		
	</mind-layout>
</template>

<script>
export default {
  components: {
	},
	created() {
		this.evtSource = new EventSource("/api/asterisk/events");
		this.evtSource
		this.evtSource.onmessage = (event) => {
			const data = JSON.parse(event.data)

			if(data.Event) {
				const ts = new Date()
				const e = data.Event
				delete data.Event
				// data.

				this.eventList.push({
					Event: e,
					Timestamp: `${ts.getFullYear()}-${ts.getMonth()+1}-${ts.getDate()} ${ts.getHours()}:${ts.getMinutes()}:${ts.getSeconds()}.${ts.getMilliseconds()}`,
					Details: data,
				})

			}
		}

	// this.evtSource.addEventListener("UserEvent", (event) => {
	// 		const data = JSON.parse(event.data)
	// 		console.log(event)
	// 		this.eventList.push(data)
	// });


	},
	beforeDestroy() {
		this.evtSource.close();
	},
	data() {
		return {
			evtSource: null,
			eventList: []
		}
	}
}
</script>
<style scoped>



</style>
